
  ; Versione inglese

  ORG 39265

  SEGUE       EQU 25043
  FONT        EQU 25044
  DISS        EQU 25812
  DZX7        EQU 25990
  FADER       EQU 25812
  NAZ         EQU 24600

  CALL DISS

  XOR A
  CALL 8859                  ; BORDER 0

; A questo punto i finali differiscono a seconda della nazione scelta

  LD A,(NAZ)
  CP 1
  JR Z, FINUSA

FINURSS:

  LD HL, FIN2
  LD DE, 16384
  CALL DZX7                 ; decomprime la schermata di vittoria
  LD HL, MUS_URSS           ; carica l'indirizzo della musica URSS
  LD (PLAYER+1),HL          ; modifica il "player" opportunamente
  LD HL, TESTO_URSS         ; carica in HL l'indirizzo del messaggio
  JR SCROLL

FINUSA:

  LD HL, FIN1
  LD DE, 16384
  CALL DZX7                 ; decomprime la schermata di vittoria
  LD HL, MUS_USA            ; carica l'indirizzo della musica URSS
  LD (PLAYER+1),HL          ; modifica il "player" opportunamente
  LD HL, TESTO_USA          ; carica in HL l'indirizzo del messaggio

; Codice scritta scorrevole

SCROLL:

  PUSH HL
  CALL im2_enable            ; Avviamo la musica
  POP HL

  LD (MESSAGGIO),HL          ; carica l'indirizzo del messaggio in MESSAGGIO
  LD (L_35489),HL            ; punta alla prima lettera del messaggio
  
L_35381:  CALL 00654
  INC E
  JR NZ, L_35381
L_35387:  HALT
  CALL 00654                 ; chiama la routine di controllo tasti
  INC E                      ; aumenta di 1 il valore di E, se è 255 (nessun tasto premuto) passa a 0
  JP NZ, USCITA              ; JP NZ, MENU_START ; RET NZ per uscire (se è stato premuto un tasto E non può essere 255)
  CALL L_35414
  JP L_35387
L_35413: DEC C
L_35414:  LD HL,20735        ; 20735 (default)
  PUSH HL
  LD B,008
L_35420:  PUSH BC
  PUSH HL
  LD B,032
  AND A
L_35425:  RL (HL)
  DEC L
  DJNZ L_35425
  POP HL
  INC H
  POP BC
  DJNZ L_35420
  LD HL,(L_35489)            ; get current place in the text
  LD L,(HL)                  ; get the letter 
  LD H,0  
  ADD HL,HL
  ADD HL,HL
  ADD HL,HL                  ; letter times 8
  LD DE,FONT-256             ; get font address ( don't forget its minus 256 -> 32*8 )
  ADD HL,DE                  ; HL now address of the character in the font
  EX DE,HL                   ; exchange so DE is letter in memory we wish to use
  POP HL                     ; retrieve where on screen we are going to put this vertical line of pixels
  LD A,(PUNTO_A)
  LD C,A
  LD B,008
L_35459:  LD A,(DE)
  AND C
  JR Z,L_35464
  INC (HL)
L_35464:  INC H
  INC DE
  DJNZ L_35459
  LD HL,PUNTO_A
  RRC (HL)
  RET NC
  LD HL,(L_35489)
  INC HL
  LD A,(HL)
  AND A
  JR NZ,L_35485
  LD HL,(MESSAGGIO)
L_35485:  LD (L_35489),HL

   RET

L_35489: DEFS 2  ;AND H
  ;ADC A,D
  ;ADD A,B
  
MESSAGGIO: DEFS 2

PUNTO_A:  ADD A,B 

; Fine della scena

USCITA:              

  LD A,7
  CALL 8859                  ; BORDER 7

  CALL im2_disable           ; spegne la musica
  CALL FADER
  
FINE:

  LD A,8
  LD (SEGUE),A

  RET                        ; torna al programma di gestione

; Routine per avvio musica (83 byte)

im2_enable                   ; inizializza gli interrupt

	di
	call PLAYER              ; richiama il "player" della musica

	ld hl,64512              ; creazione della tavola all'indirizzo specificato
	ld a,h
	ld i,a
	im 2
	dec a
	ld (hl),a
	inc l
	jr nz,$-2
	inc h
	ld (hl),a

	ld l,a                   ; predispone l'esecuzione della musica
	ld h,a
	ld de,im2_proc           ; carica la parte di esecuzione (im2_proc)

	ld (hl),195
	inc l
	ld (hl),e
	inc l
	ld (hl),d
	ei
	ret

im2_disable                  ; disabilita la musica

	di
	call PLAYER+8            ; il chip AY viene "spento"
	ld a,63
	ld i,a
	im 1
	ei
	ret

im2_proc                     ; inizio della routine degli interrupt

	di

    push          af         ; immagazzina i registri
    push          hl
    push          bc
    push          de
    push          ix
    push          iy
    exx
    ex af,af'
    push          af
    push          hl
    push          bc
    push          de

    call PLAYER+5            ; la musica viene eseguita
	ld hl,23672
	inc (hl)                 ; lettura della tastiera

    pop           de
    pop           bc
    pop           hl
    pop           af
    ex af,af'
    exx
    pop           iy
    pop           ix
    pop           de
    pop           bc
    pop           hl
    pop           af
    
	ei
    reti

  ; Schermate di vittoria

FIN1:     INCBIN "vitt_usa-ZX7.bin"
FIN2:     INCBIN "vitt_urss-ZX7.bin"

  ; Musica: ORG 45872

PLAYER:   INCBIN "Player-45872.bin"

  DEFS 541

MUS_USA:  INCBIN "Mus1.bin"
MUS_URSS: INCBIN "Mus2.bin"

  ; Messaggi di congratulazioni

TESTO_USA:

  DEFM " YOU MADE IT, DIRECTOR! "
  DEFM "YOU ACCOMPLISHED A FEAT THAT "
  DEFM "WILL REMAIN IN HISTORY FOREVER. "
  DEFM "THE PRESIDENT RECEIVES YOU "
  DEFM "AT THE WHITE HOUSE TO "
  DEFM "PERSONALLY THANK YOU, "
  DEFM "AND YOU ARE AWARDED "
  DEFM "THE MEDAL OF LIBERTY "
  DEFM "AND THE CONGRESS GOLD MEDAL."

  DEFM "        " ; 8 spazi
  
  DEFB 0

TESTO_URSS:

  DEFM " CONGRATULATIONS, COMRADE "
  DEFM "GENERAL DIRECTOR! "
  DEFM "YOU WERE ABLE TO LEAD THE "
  DEFM "EFFORTS OF OUR HEROIC PEOPLE "
  DEFM "TOWARDS A HISTORICAL ACHIEVEMENT. "
  DEFM "THE POLITBURO THANKS YOU "
  DEFM "AND YOU ARE AWARDED THE "
  DEFM "TITLE OF HERO OF THE UNION "
  DEFM "AND THE ORDER OF LENIN. "

  DEFM "        " ; 8 spazi
  
  DEFB 0