  ' Pianificatore missioni
  ' ----------------------

  ' miss(codice,missione)
  ' mpr(codice)
  ' Si possono programmare sino a 3 missioni per stagione.
  ' Ogni missione è contraddistinta da un codice così strutturato:
  ' 1: Veicolo (1-8)
  ' 2: Destinazione (1-3)
  ' 3: Modulo lunare (0, 9 o 10)
  ' 4: Razzo vettore (13-16)
  ' 5: Booster (0 o 1)
  ' 6: Modulo di servizio A (0 o 1)
  ' 7: Modulo di servizio B (0 o 1)
  ' 8: Modulo di aggancio (0 o 1)
  ' 9: Tute AEV (0, 1, 2 o 4)
  '10: Pilota 1 (0-10)
  '11: Pilota 2 (0-10)
  '12: Pilota 3 (0-10)
  '13: Pilota 4 (0-10)
  '14: Percentuale di successo
  '15: Rampa di lancio assegnata
  '16: Divisore per calcolare l'efficienza media della missione

  ' 1: Veicolo?
  '    1. Satellite orbita terrestre (Explorer, Sputnik)
  '    2. Satellite orbita lunare (Ranger, Luna)
  '    3. Sonda lunare
  '    4. Capsula monoposto
  '    5. Capsula biposto
  '    6. Capsula triposto
  '    7. Navetta (riutilizzabile)
  '    8. Veicolo lunare
  ' 2: Destinazione?
  '    1. Orbita terrestre
  '    2. Orbita lunare
  '    3. Suolo lunare
  '    - Se veicolo = 1 o 4 la destinazione è automaticamente 1; salta questo passaggio
  '    - Se veicolo = 2 la destinazione è automaticamente 2; salta questo passaggio
  '    - Se veicolo = 3 la destinazione è automaticamente 3; salta questo passaggio
  '    - Se veicolo = 5 e destinazione = 3 aggiungi ML monoposto, MS tipo A, modulo aggancio e tuta AEV
  '    - Se veicolo = 6 e destinazione = 3 aggiungi ML biposto e 2 tute AEV
  '    - Se veicolo = 7 e destinazione = 3 aggiungi ML biposto, MS tipo B, modulo aggancio e 4 tute AEV
  ' 3: Vettore? (mostrare carico utile)
  '    1. Razzo leggero
  '    2. Razzo medio
  '    3. Razzo pesante
  '    4. Razzo super
  '    + eventuale potenziamento (solo per leggero e medio)
  ' 4: AEV? (solo se veicolo > 4 e destinazione < 3)
  '    1. Sì (aggiungi 1 o 2 tute AEV)
  '    2. No
  ' 5: Scelta equipaggio (solo se veicolo > 3)
  '    - Se veicolo = 4 scegli 1 pilota
  '    - Se veicolo = 5 scegli 2 piloti
  '    - Se veicolo = 6 o 7 scegli 3 piloti
  '    - Se veicolo = 8 scegli 4 piloti
  ' 6: Rivedere tutta la configurazione della missione;
  ' calcolare efficienza media e sottrarre eventuale penalità
  ' per ogni Pietra Miliare non effettuata
  '    1: Conferma
  '    2: Annulla

  #INCLUDE "_intestazione.bas"

  ' ----------------------------------------
  ' ---------- RECUPERO VARIABILI ----------
  ' ----------------------------------------

  DIM x, y, z, n, w, k, i, q AS UBYTE

  DIM naz AS UBYTE
  naz = PEEK (@memo)

  DIM stru(3,9) AS UBYTE
  x = 1
  DO
    stru(1,x) = PEEK (@memo + 10 + x)
    stru(2,x) = PEEK (@memo + 19 + x)
    stru(3,x) = PEEK (@memo + 28 + x)
    x = x + 1
  LOOP UNTIL x = 10

  DIM abi(8,10) AS UBYTE
  x = 1
  DO
    abi(1,x) = PEEK (@memo + 37 + x)
    abi(2,x) = PEEK (@memo + 47 + x)
    abi(3,x) = PEEK (@memo + 57 + x)
    abi(4,x) = PEEK (@memo + 67 + x)
    abi(5,x) = PEEK (@memo + 77 + x)
    abi(6,x) = PEEK (@memo + 87 + x)
    abi(7,x) = PEEK (@memo + 97 + x)
    abi(8,x) = PEEK (@memo + 107 + x)
    x = x + 1
  LOOP UNTIL x = 11

  ' Descrizione materiale:
  ' Ogni materiale è contraddistinto da un numero, che serve da guida
  ' per tutte le variabili relative a esso.
  
  '  1 - Satellite orbitale terrestre
  '  2 - Satellite orbitale lunare
  '  3 - Sonda lunare
  '  4 - Capsula monoposto
  '  5 - Capsula biposto
  '  6 - Capsula triposto
  '  7 - Mini navetta riutilizzabile
  '  8 - Veicolo lunare
  '  9 - Modulo lunare monoposto  
  ' 10 - Modulo lunare biposto
  ' 11 - Modulo aggancio
  ' 12 - Tuta AEV
  ' 13 - Razzo vettore leggero
  ' 14 - Razzo vettore medio
  ' 15 - Razzo vettore pesante
  ' 16 - Razzo vettore super
  ' 17 - Parte ausiliaria
  ' 18 - Modulo servizio A
  ' 19 - Modulo servizio B

  DIM massa(19) AS UBYTE
  DIM qt(19) AS UBYTE
  DIM rsatt(19) AS UBYTE
  DIM effatt(19) AS BYTE
  x = 1
  DO
    massa(x) = PEEK (@memo + 211 + x)
    qt(x) = PEEK (@memo + 230 + x)
    rsatt(x) = PEEK (@memo + 249 + x)
    effatt(x) = PEEK (@memo + 268 + x)
    x = x + 1
  LOOP UNTIL x = 20

  DIM cu(5) AS UBYTE
  x = 1
  DO
    cu(x) = PEEK (@memo + 325 + x)
    x = x + 1
  LOOP UNTIL  x = 6

  DIM miss(16,3) AS UBYTE
  DIM effmis(3) AS BYTE
  DIM totalmis(3) AS UBYTE
  x = 1
  DO
    miss(1,x) = PEEK (@memo + 330 + x)
    miss(2,x) = PEEK (@memo + 333 + x)
    miss(3,x) = PEEK (@memo + 336 + x)
    miss(4,x) = PEEK (@memo + 339 + x)
    miss(5,x) = PEEK (@memo + 342 + x)
    miss(6,x) = PEEK (@memo + 345 + x)
    miss(7,x) = PEEK (@memo + 348 + x)
    miss(8,x) = PEEK (@memo + 351 + x)
    miss(9,x) = PEEK (@memo + 354 + x)
    miss(10,x) = PEEK (@memo + 357 + x)
    miss(11,x) = PEEK (@memo + 360 + x)
    miss(12,x) = PEEK (@memo + 363 + x)
    miss(13,x) = PEEK (@memo + 366 + x)
    miss(14,x) = PEEK (@memo + 369 + x)
    miss(15,x) = PEEK (@memo + 372 + x)
    miss(16,x) = PEEK (@memo + 375 + x)
    effmis(x) = PEEK (@memo + 378 + x)
    totalmis(x) = PEEK (@memo + 381 + x)
    x = x + 1
  LOOP UNTIL x = 4

  DIM mpr(16) AS UBYTE
/'
  x = 1
  DO
    mpr(x) = PEEK (@memo + 384 + x)
    x = x + 1
  LOOP UNTIL x = 17
'/

  DIM pm(6) AS UBYTE
  x = 1
  DO
    pm(x) = PEEK (@memo + 400 + x)
    x = x + 1
  LOOP UNTIL x = 7

  DIM pmbon(6) AS UBYTE => {12,16,8,10,12,20}

  DIM somma AS INTEGER
  somma = PEEK (UINTEGER, @memo + 408)

  DIM pen AS UBYTE
  pen = PEEK (@memo + 415)

  DIM pilost$(10)
  x = 1
  DO
    pilost$(x) = CHR$(PEEK(@memo + 415 + x))
    x = x + 1
  LOOP UNTIL x = 11

  DIM mate$(19)
  IF naz = 1 THEN
    mate$(1) = "EXPLORER"
    mate$(2) = "RANGER"
    mate$(3) = "SURVEYOR"
    mate$(4) = "MERCURY"
    mate$(5) = "GEMINI"
    mate$(6) = "APOLLO"
    mate$(7) = "XMS-2"
    mate$(8) = "JUPITER"
    mate$(9) = "LM-1"
    mate$(10) = "LEM"
    mate$(13) = "ATLAS"
    mate$(14) = "TITAN"
    mate$(15) = "SATURN V"
    mate$(16) = "NOVA"
    mate$(17) = "BOOSTER"
  ELSE
    mate$(1) = "SPUTNIK"
    mate$(2) = "KOSMOS"
    mate$(3) = "LUNA"
    mate$(4) = "VOSTOK"
    mate$(5) = "VOSKHOD"
    mate$(6) = "SOYUZ"
    mate$(7) = "SPIRAL"
    mate$(8) = "LK-700"
    mate$(9) = "LK"
    mate$(10) = "LEK"
    mate$(13) = "R-7"
    mate$(14) = "11A511"
    mate$(15) = "N1"
    mate$(16) = "UR-700"
    mate$(17) = "AUX.STAGE"
  END IF

  mate$(11) = "DOCKING MOD."
  mate$(12) = "EVA SUIT"
  mate$(18) = "SER.MOD.A"
  mate$(19) = "SER.MOD.B"

  rigav$ = "                                "
  sce1$ = "\{i7}\{b1} 1 "
  sce0$ = "\{i7}\{b1} 0 "
  ind$ = "(0=BACK)"
  disp$ = "AVAIL."
  pianmis$ = " MISSION PLANNER "
  mispian$ = " PLANNED MISSIONS "
  sino$ = "1=YES/2=NO "

  IF naz = 1 THEN
    plt$ = " ASTR"
  ELSE
    plt$ = " COSM"
  END IF

  DIM pilo$(10)
  IF naz = 1 THEN
    pilo$(1) = "SHEPARD"
    pilo$(2) = "GLENN"
    pilo$(3) = "COOPER"
    pilo$(4) = "SCHIRRA"
    pilo$(5) = "GRISSOM"
    pilo$(6) = "YOUNG"
    pilo$(7) = "COLLINS"
    pilo$(8) = "ARMSTRONG"
    pilo$(9) = "ALDRIN"
    pilo$(10) = "WHITE"
  ELSE
    pilo$(1) = "GAGARIN"
    pilo$(2) = "TITOV"
    pilo$(3) = "LEONOV"
    pilo$(4) = "TERESHKOVA"
    pilo$(5) = "BYKOVSKY"
    pilo$(6) = "BELYAYEV"
    pilo$(7) = "GORBATKO"
    pilo$(8) = "KOMAROV"
    pilo$(9) = "BEREGOVOY"
    pilo$(10) = "POPOVICH"
  END IF

  DIM abl$(5)
  abl$(1) = "BASE PILOTING"
  abl$(2) = "EVA"
  abl$(3) = "DOCKING"
  abl$(4) = "ADV.PILOTING"
  abl$(5) = "ENDURANCE"

  ' --------------------------------------
  ' ---------- INIZIO PROGRAMMA ----------
  ' --------------------------------------

missioni:

  INK 0: CLS

  lista(3,1,2)

  PRINT AT 3,4; pianmis$; AT 5,4; mispian$; AT 1,11; PAPER naz; "\{i7}\{b1} MISSIONS "

attesa12:

  PAUSE 0

  IF INKEY$="1" THEN bip(): GOTO pianifica
  IF INKEY$="2" THEN bip(): GOTO vedimiss
  IF INKEY$="0" THEN GOTO main

  GOTO attesa12

  ' Pianificazione nuove missioni

pianifica:

  CLS

  ' Verifica se ci sono rampe di lancio disponibili controllando le rampe assegnate alle tre possibili missioni del turno

  IF stru(1,1) <> 1 AND stru(1,2) <> 1 AND stru(1,3) <> 1 THEN POKE UINTEGER indir,@norampa: stampa(): premitasto(): GOTO missioni

  ' Assegna a mpr(15) la prima rampa disponibile e determina il numero d'ordine della missione corrente

  IF miss(15,1) = 0 THEN i = 1 : GOTO intestamis
  IF miss(15,2) = 0 THEN i = 2 : GOTO intestamis
  IF miss(15,3) = 0 THEN i = 3

intestamis:

  PRINT AT 1,6; PAPER naz; INK 7; BRIGHT 1; pianmis$

  intemis()

  azzemis(): mpr(15) = i

  ' Il divisore della missione parte sempre da un minimo di 2 (veicolo + vettore)

  mpr(16) = 2

  ' Stampa la lista dei veicoli con quantità, massa ed efficienza attuale

  n = 1
  DO
    k = n + 3
    PRINT AT k,1; n;".";mate$(n); AT k,18; qt(n); AT k,22; massa(n); AT k,25; effatt(n);"%"
	n = n + 1
  LOOP UNTIL n = 9

  ' Chiedi quale veicolo lanciare

  PRINT AT 19,1; "SPACECRAFT? ";ind$

chiediveic:

  inp()

  IF i = 0 THEN GOTO annullamis

  IF i > 8 THEN GOTO chiediveic

  ' Veicolo non disponibile

  IF qt(i) = 0 THEN GOTO chiediveic

  ' Assegna il veicolo alla missione in corso

  mpr(1) = i

  ' Aggiunge alla somma l'efficienza attuale del veicolo prescelto

  somma = effatt(i)

  ' Se veicolo = 1 o 4 la destinazione è automaticamente 1; vai subito alla scelta del vettore
  
  IF i = 1 OR  i = 4 THEN mpr(2) = 1 : GOTO razzi

  ' Se veicolo = 2 la destinazione è automaticamente 2; vai subito alla scelta del vettore

  IF i = 2 THEN mpr(2) = 2 : GOTO razzi

  ' Se veicolo = 3 la destinazione è automaticamente 3; vai subito alla scelta del vettore

  IF i = 3 THEN mpr(2) = 3 : GOTO razzi

  ' Chiedi la destinazione

  pulisci()

  POKE UINTEGER indir,@chiedides: stampa()

  PRINT AT 19,15;ind$

chiedidest:

  inp()

  IF i = 0 THEN GOTO annullamis

  IF i > 3 THEN GOTO chiedidest
  
  ' Assegna la destinazione alla missione

  mpr(2) = i  

  ' Notifica se la missione richiede materiale aggiuntivo

  pulisci()

  w = 0

  ' Destinazione orbita lunare (mpr(2)=2)
  ' Capsula biposto (mpr(1)=5): aggiungi MS tipo A
  ' Capsula triposto (mpr(1)=6): aggiungi MS tipo B

  IF mpr(2) = 2 AND mpr(1) = 5 THEN necessita(): PRINT AT 6,1; mate$(18): mpr(6) = 1: mpr(16) = mpr(16) + 1: GOTO checkmiss4
  IF mpr(2) = 2 AND mpr(1) = 6 THEN necessita(): PRINT AT 6,1; mate$(19): mpr(7) = 1: mpr(16) = mpr(16) + 1: GOTO checkmiss5

  ' Destinazione suolo lunare ( mpr(2) = 3 ):
  ' Capsula biposto ( mpr(1) = 5 ); aggiungi ML monoposto, MS tipo A, modulo aggancio e tuta AEV
  ' Capsula triposto ( mpr(1) = 6 ); aggiungi ML biposto, MS tipo B, modulo aggancio e 2 tute AEV
  ' Navetta riutilizzabile ( mpr(1) = 7 ); aggiungi ML biposto, modulo aggancio e 2 tute AEV
  ' Veicolo lunare ( mpr(1) = 8 ); aggiungi 2 tute AEV
  ' In tutti questi casi aumenta la media in relazione al numero di materiali (1 o 2 tute AEV non fa differenza)
  
  IF mpr(1) = 5 AND mpr(2) = 3 THEN necessita(): PRINT AT 5,1; mate$(9); AT 6,1; mate$(18); AT 7,1; mate$(11); AT 8,1; mate$(12); " (1)": mpr(3) = 9: mpr(6) = 1: mpr(8) = 1: mpr(9) = 1: mpr(16) = mpr(16) + 4: GOTO checkmiss1
  IF mpr(1) = 6 AND mpr(2) = 3 THEN necessita(): PRINT AT 5,1; mate$(10); AT 6,1; mate$(19); AT 7,1; mate$(11); AT 8,1; mate$(12); " (2)": mpr(3) = 10: mpr(7) = 1: mpr(8) = 1: mpr(9) = 2: mpr(16) = mpr(16) + 4: GOTO checkmiss3
  IF mpr(1) = 7 AND mpr(2) = 3 THEN necessita(): PRINT AT 5,1; mate$(10); AT 6,1; mate$(11); AT 7,1; mate$(12); " (2)": mpr(3) = 10: mpr(8) = 1: mpr(9) = 2: mpr(16) = mpr(16) + 3: GOTO checkmiss2
  IF mpr(1) = 8 AND mpr(2) = 3 THEN necessita(): PRINT AT 5,1; mate$(12); " (2)": mpr(9) = 2: mpr(16) = mpr(16) + 1: GOTO checkmiss6

  ' Chiedi quale razzo vettore utilizzare.
  ' I razzi vanno da 13 a 16

razzi:

  ' Azzera y, servirà eventualmente per decidere in seguito la necessità del potenziamento

  y = 0

  intemis()
  
  PRINT AT 19,1; "CARRIER? " ;ind$; AT 3,21; INK naz; "PAY"

  ' Stampa la lista dei vettori e il loro carico utile
  
  n = 13
  DO
    k = n - 9
    PRINT AT k,1; n-12;".";mate$(n); AT k,18; qt(n); AT k,22; cu(n-12); AT k,25; effatt(n);"%"
	n = n + 1
  LOOP UNTIL n = 17
  
chiedivett:

  inp()

  IF i = 0 THEN GOTO annullamis
  IF i > 4 THEN GOTO chiedivett

  ' Assegna il razzo alla missione

  mpr(4) = i + 12

  ' Se vettore > 2 controlla che ci sia un laboratorio di assemblaggio veicoli grandi

  IF i > 2 AND stru(1,7) <> 1 THEN nostru(): GOTO missioni

  ' Vettore non disponibile

  IF qt(i+12) = 0 THEN GOTO chiedivett

  ' Se la destinazione è 1 o il razzo è pesante o super non serve il potenziamento
  
  IF mpr(2) = 1 OR mpr(4) > 14 THEN GOTO razzoscelto

  ' Se la destinazione è > 1 e il razzo è leggero non è possibile continuare

  IF mpr(2) > 1 AND i = 1 THEN POKE UINTEGER indir,@nonadatto: stampa(): premitasto(): GOTO razzi

  ' Se la destinazione è > 1 è il razzo è medio serve il potenziamento (y = 1)

  IF mpr(2) > 1 AND i = 2 THEN POKE UINTEGER indir,@boos: y = 255: stampa()

  premitasto()

  ' Controlla se abbiamo potenziamenti a disposizione

  IF qt(17) = 0 THEN GOTO checkrazzo

  ' Se y = 255 aggiunge automaticamente il potenziamento, se disponibile 

  IF qt(17) > 0 AND y = 255 THEN mpr(5) = 1 : GOTO checkrazzo

  ' Chiede se si desidera il potenziamento (se disponibile)
  
chiedipot:

  PRINT AT 18,1; mate$(17);"?"; AT 19,1; sino$;ind$; AT 1,6; PAPER naz; INK 7; BRIGHT 1; pianmis$

  inp()

  IF i = 0 THEN GOTO annullamis

  ' Aggiungi il potenziamento

  IF i = 1 THEN mpr(5) = 1: GOTO checkrazzo

  ' Non aggiungere il potenziamento

  IF i = 2 THEN GOTO checkrazzo

  ' Input non valido

  GOTO chiedipot

  ' Controlla se il vettore, più eventuale potenziamento, ha un carico utile sufficiente

checkrazzo:

  ' Se la destinazione è > 1 è il razzo è medio serve il potenziamento

  IF mpr(5) = 0 AND y = 255 THEN POKE UINTEGER indir,@nonnehai: stampa(): premitasto(): GOTO razzi

razzoscelto:

  ' Memorizza il razzo prescelto in y

  y = mpr(4)

  ' Aggiunge alla somma l'efficienza attuale del razzo prescelto

  somma = somma + effatt(y)

  ' Inserisci in x il carico utile del razzo prescelto

  x = cu(y-12)

  ' Aggiungi l'eventuale potenziamento

  IF mpr(5) = 1 THEN x = x + cu(5): y = mpr(5): somma = somma + effatt(17)

  ' Calcola la massa complessiva del materiale da lanciare e memorizzala in w.
  ' Ricorda che il materiale da lanciare può essere:
  ' 1: Veicolo (1-8)
  ' 3: Modulo lunare (0, 9 o 10)
  ' 6: Modulo di servizio A (0 o 1)
  ' 7: Modulo di servizio B (0 o 1)
  ' 8: Modulo di aggancio (0 o 1)

  ' Massa del veicolo

  y = mpr(1)
  w = massa(y)

  ' Massa dell'eventuale modulo lunare

  y = mpr(3)
  IF y <> 0 THEN w = w + massa(y)

  ' Massa degli eventuali modulo di servizio e aggancio

  IF mpr(6) = 1 THEN w = w + massa(17)
  IF mpr(7) = 1 THEN w = w + massa(18)
  IF mpr(8) = 1 THEN w = w + massa(11)

  ' Confronta la massa del materiale da lanciare con il carico utile

  pulisci()

  PRINT AT 3,1; "TOTAL MASS: ";w; AT 5,1; "PAYLOAD: ";x

  ' Massa da lanciare eccessiva

  IF w > x THEN POKE UINTEGER indir,@massaec: stampa(): premitasto(): GOTO razzi

  ' La massa da lanciare rientra nel carico utile disponibile.
  ' Se abbiamo aggiunto il potenziamento aumenta di 1 il divisore per la media
  ' e aggiungi la sua efficienza attuale alla somma

  IF mpr(5) = 1 THEN mpr(16) = mpr(16) + 1: somma = somma + effatt(17)

  premitasto()

  ' Chiede se effettuare un'AEV.
  ' Questa domanda si pone solo se mpr(1) è uno di questi:
  '   5. Capsula biposto
  '   6. Capsula triposto
  '   7. Navetta (riutilizzabile)
  '   8. Veicolo lunare
  ' e se mpr(2) = 1 (orbita terrestre).
  ' Le missioni sul suolo lunare prevedono sempre l'AEV.

chiediaev:

  pulisci()

  ' La missione non richiede AEV

  IF mpr(1) < 5 OR mpr(2) = 2 THEN GOTO sceglipilo

  ' La missione deve richiedere l'AEV
  
  IF mpr(2) = 3 THEN GOTO tuta

  ' La missione può richiedere l'AEV

  PRINT AT 18,1; "PERFORM AN EVA?"; AT 19,1; sino$; ind$

effettaev:

  inp()

  IF i = 0 THEN GOTO annullamis
  IF i > 2 THEN GOTO effettaev
  IF i = 2 THEN GOTO sceglipilo

tuta:
 
  PRINT AT 3,1; necess$

  ' Modulo lunare biposto e veicolo lunare richiedono 2 tute AEV

  IF mpr(1) = 8 OR mpr(3) = 10 THEN
    PRINT AT 4,1; "2 EVA SUITS"
    w = 2
  ELSE
    PRINT AT 4,1; "1 EVA SUIT"
	w = 1
  END IF

  PRINT AT 6,1; disp$;" EVA SUITS: ";qt(12)

  ' Tuta AEV non disponibile

  IF qt(12) = 0 THEN POKE UINTEGER indir,@materialino: stampa(): premitasto(): GOTO chiediaev

  ' Se la tuta AEV è disponibile aggiungine il numero in mpr(9) e aggiungi la sua efficienza attuale alla somma

  mpr(9) = w

  somma = somma + effatt(12)

  ' Se l'AEV è facoltativa (la destinazione non è il suolo lunare) aggiungi 1 al quoziente per la media

  IF mpr(2) <> 3 THEN mpr(16) = mpr(16) + 1
  
  ' Scegli i piloti per le missioni con equipaggio.
  ' Questa scelta si effettua solo se mpr(1) > 3

  premitasto()

sceglipilo:

  ' Se sono satelliti o la sonda non serve equipaggio

  IF mpr(1) < 4 THEN GOTO rivedimis

  CLS

  ' Chiede se si vuole effettuare una missione con equipaggio.

  ' La missione atterraggio lunare deve sempre essere inviata con equipaggio.

  IF mpr(2) = 3 THEN GOTO mostrapilo

equisino:

  PRINT AT 18,1; "MANNED? ";AT 19,1; sino$; ind$

  inp()

  IF i = 0 THEN GOTO annullamis
  IF i = 2 THEN cancepilo(): GOTO rivedimis
  IF i > 2 THEN GOTO equisino

mostrapilo:

  elenpilo()

  ' se k = 2 non ci sono piloti, si può solo inviare il veicolo senza equipaggio come test se la destinazione non è il suolo lunare

  IF k = 2 AND mpr(2) < 3 THEN GOTO rivedimis
  IF k = 2 AND mpr(2) = 3 THEN GOTO annullamis

  ' Se veicolo = 4 scegli 1 pilota
  ' Se veicolo = 5 scegli 2 piloti
  ' Se veicolo = 6 o 7 scegli 3 piloti
  ' Se veicolo = 8 scegli 4 piloti

  ' Determina il numero dei piloti necessari e lo memorizza in z

  IF mpr(1) = 4 THEN z = 1
  IF mpr(1) = 5 THEN z = 2
  IF mpr(1) = 6 OR mpr(1) = 7 THEN z = 3
  IF mpr(1) = 8 THEN z = 4

  ' Controlla se il pilota è adatto per la missione: verifica abi(abilità,pilota).
  ' Le abilità richieste sono:
  ' 1. PB Pilotaggio base (solo capsule): mpr(1) < 7
  ' 2. EV (solo missioni con AEV o atterraggi lunari con equipaggio): mpr(9) <> 0 o mpr(3) <> 0
  ' 3. AG Aggancio (solo missioni con modulo aggancio): mpr(8) <> 0
  ' 4. PA Pilotaggio avanzato (solo missioni orbita/suolo lunare con equipaggio): mpr(1) > 4 e mpr(2) > 1
  ' 5. RS Resistenza a lungo termine (solo missioni orbita/suolo lunare con equipaggio): mpr(1) > 4 e mpr(2) > 1
  ' Il pilota è adatto per la missione se ha almeno 1 punto per ciascuna abilità richiesta.

  cancepilo()

  ' Contatore per la memorizzazione dei piloti: mpr(y), con y che può andare da 10 a 14

  y = 10

chiedipilo:

  PRINT AT 18,0; rigav$; AT 19,0; rigav$; AT 19,1; z;plt$;"ONAUTS REQUIRED"
  IF z = 1 THEN PRINT AT 19,12; " REQUIRED "

  inp()

  IF i = 0 THEN GOTO annullamis
  IF i > 10 THEN GOTO chiedipilo

  ' Pilota non disponibile

  IF pilost$(i) <> "A" THEN
    POKE UINTEGER indir,@pilono
    stampa()
    PRINT AT 21,4; FLASH 1; plt$
    premitasto()
    cancerig()
    GOTO chiedipilo
  END IF

  ' Non memorizzare il numero del pilota se è già stato selezionato

  k = 0

  n = 10
  DO
    IF mpr(n) = i THEN k = 1
	n = n + 1
  LOOP UNTIL n = 14

  IF k = 1 THEN GOTO chiedipilo

  ' In caso contrario memorizzalo
  
  mpr(y) = i
  
  ' Marca il pilota prescelto

  PRINT AT i+1,0; PAPER naz; "\{i7}\{b1}>"
  
  y = y + 1 : z = z - 1: IF z > 0 THEN GOTO chiedipilo

checkpilo:

  ' Verifica piloti.

  ' Volo orbitale terrestre: tutti addestrati in PB
  ' Se c'è AEV: almeno 1 addestrato in EV

  ' Volo orbitale lunare: Tutti addestrati in PA, RS
  ' Se c'è AEV: almeno 1 addestrato in EV

  ' Missione lunare: tutti addestrati in PA, RS
  ' Con ML monoposto: almeno 1 addestrato in EV
  ' Con ML biposto o veicolo lunare: almeno 2 addestrati in EV
  ' Con modulo aggancio: tutti addestrati in AG
  
  ' Variabili richieste:
  ' i = contatore per la riga dove stampare le abilità richieste
  ' n = contatore (10-13)
  ' k = controllo
  ' x = numero dell'abilità richiesta
  ' y = valore di mpr(n), cioè il numero di riferimento del pilota

  i = 15

  ' Se la destinazione è lunare salta questo passaggio

  IF mpr(2) > 1 THEN GOTO checkvol
  
  ' Verifica per il volo orbitale terrestre

  x = 1 : veripilo()
  
  IF k > 0 THEN noab()
  
  GOTO checkaev

  ' Verifica per il volo orbitale lunare/missione lunare

checkvol:

  x = 4 : veripilo()
  
  IF k > 0 THEN noab()

  x = 5 : veripilo()
  
  IF k > 0 THEN noab()

  ' Verifica AEV

checkaev:

  ' Se non è prevista AEV vai direttamente al riepilogo
  
  IF mpr(9) = 0 THEN GOTO checkagg ' rivedimis
  
  x = 2 : veripilo()
  
  ' AEV con capsula biposto: almeno 1 con EV (k non deve essere maggiore di 1)
  ' Questo vale per tutte le missioni, in quanto la capsula biposto può portare solo il modulo lunare monoposto.
  
  IF mpr(1) = 5 AND k > 1 THEN noab()
  
  ' AEV con capsula triposto e destinazione orbitale: almeno 1 con EV (k non deve essere maggiore di 2)
  
  IF mpr(1) = 6 AND mpr(2) < 3 AND k > 2 THEN noab()
  
  ' AEV con modulo lunare biposto o veicolo lunare: almeno 2 con EV (k non deve essere maggiore di 1)
  
  IF mpr(3) = 10 AND k > 1 THEN noab()

  IF mpr(1) = 8 AND k > 1 THEN noab()
  
  ' Verifica aggancio
  
checkagg:

  ' Se non c'è il modulo di aggancio vai direttamente al riepilogo
  
  IF mpr(8) = 0 THEN GOTO checkfine

  x = 3 : veripilo()
  
  IF k > 0 THEN noab()

checkfine:

  PRINT AT 19,0; rigav$
  premitasto()
  
  ' Se i è maggiore del suo valore iniziale significa che noab() è stato richiamato
  
  IF i > 15 THEN GOTO sceglipilo

  ' Rivedi i dati della missione

rivedimis:

  ' Controlla se non c'è equipaggio e se è stata selezionata l'AEV.
  ' In tal caso, toglie la/le tuta/e AEV, ne toglie, l'efficienza da somma e scala il quoziente mpr(16) di 1

  IF mpr(9) > 0 AND mpr(10) = 0 THEN mpr(9) = 0: somma = somma - effatt(12): mpr(16) = mpr(16) - 1

  ' Determina il numero (1-3) della missione corrente

  x = mpr(15)

  ' Copia i dati di mpr in miss(codice,numero)

  n = 1
  DO
    miss(n,x) = mpr(n)
	n = n + 1
  LOOP UNTIL n = 17

  ' Stampa il riepilogo della missione

  riepmis()

  ' Calcola la percentuale di efficienza per questa missione

  ' Media di tutto il materiale (somma/mpr(16)), penalità per ogni missione pietra miliare non effettuata prima

  w = miss(16,x)

  ' Calcolo efficienza di base
  
  effmis(x) = INT(somma/w)

  ' L'efficienza non può mai superare il 95%

  IF effmis(x) > 95 THEN effmis(x) = 95

  ' Calcola le eventuali penalità per le missioni pietre miliari non affrontate

penalita:

  ' Azzera z

  z = 0

  ' La penalità si aggiunge se una o più missioni pietre miliari non sono state completate da noi.
  ' Se pm(x) < 2 vuol dire o che non l'ha completata nessuno (0) o che l'hanno fatto i nostri avversari (1).

  ' Satellite in orbita terrestre
 
  IF pm(1) < 2 THEN z = pen

  ' Volo con capsula, navetta o veicolo (con o senza equipaggio)

  IF mpr(1) > 3 AND mpr(1) < 9 AND pm(2) < 2 THEN z = z + pen

  ' AEV 

  IF mpr(9) <> 0 AND pm(3) < 2 THEN z = z + pen

  ' Destinazione orbita lunare

  IF mpr(2) > 1 AND pm(4) < 2 THEN z = z + pen

  ' Destinazione suolo lunare

  IF mpr(2) = 3 AND pm(5) < 2 THEN z = z + pen

  ' Volo lunare C/E

  IF mpr(2) > 1 AND mpr(10) <> 0 AND pm(6) < 2 THEN z = z + pen

  ' Sottrae le penalità all'efficienza globale della missione

  effmis(x) = effmis(x) - z 

  IF effmis(x) < 0 THEN effmis(x) = 0

  ' Stampa la percentuale di efficienza per questa missione

  stampaeff()

  ' Chiedi conferma

  PRINT AT 21,8; "CONFIRM"; AT 23,8; "CANCEL"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

attendiconf:

  PAUSE 0

  IF INKEY$ = "1" THEN k = 1: GOTO esci
  IF INKEY$ = "0" THEN k = 0: GOTO esci
 
  GOTO attendiconf

esci:

  bip()

  cancerig()

  IF k = 0 THEN GOTO annullamis

escimis:

  ' Toglie dalle scorte (qt) le quantità di materiale richieste dalla missione

  ' Veicolo (sempre presente)

  w = miss(1,x)
  qt(w) = qt(w) - 1

  ' Modulo lunare

  w = miss(3,x)
  IF w <> 0 THEN qt(w) = qt(w) - 1

  ' Vettore (sempre presente)

  w = miss(4,x)
  qt(w) = qt(w) - 1  

  ' Altri materiali: 5-9.
  ' Possono essere: 
  ' - booster: qt(17), miss(5,x)
  ' - modulo servizio A: qt(18), miss(6,x)
  ' - modulo servizio B: qt(19), miss(7,x)
  ' - modulo aggancio: qt(11), miss(8,x)
  ' - tuta/e AEV qt(12), miss(9,x)
  ' In miss(n,x) hanno valore 0 o 1, tranne miss(9,x) che può essere 2 se sono assegnate 2 tute.
  
  ' Potenziamento, Modulo A, Modulo B (5-7)
  
  n = 5
  DO
    w = miss(n,x)
    IF w > 0 THEN qt(n+12) = qt(n+12) - 1
	n = n + 1
  LOOP UNTIL n = 8

  ' Modulo aggancio

  IF miss(8,x) > 0 THEN qt(11) = qt(11) - 1

  ' Tuta/e AEV

  w = miss(9,x)
  IF w > 0 THEN qt(12) = qt(12) - w

  ' Occupa la rampa assegnata

  w = miss(15,x)

  stru(1,w) = 2

  ' Marca i piloti selezionati come "in missione"

  n = 10
  DO
    q = miss(n,x)
    IF q > 0 THEN pilost$(q) = "M"
	n = n + 1
  LOOP UNTIL n = 15

  ' Missione pianificata

  CLS

  POKE UINTEGER indir,@misspianok: stampa()
  
  ' BEEP .2, 15

  premitasto()

  GOTO missioni

  ' Verifica del materiale necessario per le missioni lunari con equipaggio

checkmiss1:

  ' Verifica se qt(9),(18),(11) e (12) > 0; w è la variabile di controllo.
  ' Se i materiali sono disponibili aggiunge la loro efficienza attuale a somma

  IF qt(9) > 0 THEN
    PRINT AT 5,14; disp$
    somma = somma + effatt(9)
  ELSE
    PRINT AT 5,14; "UN";disp$ : w = 1
  END IF
  IF qt(18) > 0 THEN
    PRINT AT 6,14; disp$
    somma = somma + effatt(18) 
  ELSE
    PRINT AT 6,14; "UN";disp$ : w = 1
  END IF
  IF qt(11) > 0 THEN
    PRINT AT 7,14; disp$
    somma = somma + effatt(11) 
  ELSE
    PRINT AT 7,14; "UN";disp$ : w = 1
  END IF
  IF qt(12) > 0 THEN
    PRINT AT 8,14; disp$
    somma = somma + effatt(12)
  ELSE
    PRINT AT 8,14; "UN";disp$ : w = 1
  END IF

  GOTO finecheck

checkmiss2:

  ' Verifica se qt(10),(11) > 0 e (12) > 3; w è la variabile di controllo.
  ' Se i materiali sono disponibili aggiunge la loro efficienza attuale a somma

  IF qt(10) > 0 THEN
    PRINT AT 5,14; disp$
    somma = somma + effatt(10)
  ELSE
    PRINT AT 5,14; "UN";disp$ : w = 1
  END IF
  IF qt(11) > 0 THEN
    PRINT AT 7,14; disp$
    somma = somma + effatt(11)
  ELSE
    PRINT AT 7,14; "UN";disp$ : w = 1
  END IF
  IF qt(12) > 3 THEN
    PRINT AT 6,14; disp$
    somma = somma + effatt(12)
  ELSE
    PRINT AT 6,14; "UN";disp$ : w = 1
  END IF

  GOTO finecheck

checkmiss3:

  ' Verifica se qt(10),(19),(11) > 0 e (12) > 1; w è la variabile di controllo.
  ' Se i materiali sono disponibili aggiunge la loro efficienza attuale a somma

  IF qt(10) > 0 THEN
    PRINT AT 5,14; disp$
    somma = somma + effatt(10)
  ELSE
    PRINT AT 5,14; "UN";disp$ : w = 1
  END IF
  IF qt(19) > 0 THEN
    PRINT AT 6,14; disp$
    somma = somma + effatt(19)
  ELSE
    PRINT AT 6,14; "UN";disp$ : w = 1
  END IF
  IF qt(11) > 0 THEN
    PRINT AT 7,14; disp$
    somma = somma + effatt(11)
  ELSE
    PRINT AT 7,14; "UN";disp$ : w = 1
  END IF
  IF qt(12) > 1 THEN
    PRINT AT 8,14; disp$
    somma = somma + effatt(12)
  ELSE
    PRINT AT 8,14; "UN";disp$ : w = 1
  END IF

  GOTO finecheck

checkmiss4:

  IF qt(18) > 0 THEN
    PRINT AT 6,14; disp$
    somma = somma + effatt(18)
  ELSE
    PRINT AT 6,14; "UN";disp$ : w = 1
  END IF

  GOTO finecheck

checkmiss5:

  IF qt(19) > 0 THEN
    PRINT AT 6,14; disp$
    somma = somma + effatt(19)
  ELSE
    PRINT AT 6,14; "UN";disp$ : w = 1
  END IF

  GOTO finecheck

  ' Verifica la presenza delle tute AEV per la missione lunare con veicolo lunare

checkmiss6:

  IF qt(12) > 1 THEN
    PRINT AT 5,14; disp$
    somma = somma + effatt(12)
  ELSE
    PRINT AT 5,14; "NON ";disp$ : w = 1
  END IF

finecheck:

  IF w = 1 THEN
    POKE UINTEGER indir,@materialino
    stampa()
    premitasto()
    GOTO annullamis
  ELSE
    premitasto()
    GOTO razzi
  END IF

  ' Annulla la missione in corso di programmazione (nessuna penalità)

annullamis:

  ' Memorizza in i il numero della missione corrente

  i = mpr(15)

  azzemis()

  GOTO missioni

  ' Visualizza le missioni programmate per il turno successivo

vedimiss:

  CLS

  ' Controlla se ci sono missioni programmate

  IF miss(15,1) = 0 AND miss(15,2) = 0 AND miss(15,3) = 0 THEN POKE UINTEGER indir,@nomissp: stampa(): premitasto(): GOTO missioni

  k = 5 : POKE UINTEGER indir,@missione1 : stampa() : PRINT AT 1,5; PAPER naz; INK 7; BRIGHT 1; mispian$; AT 3,3; sce1$

  IF miss(15,2) = 2 THEN POKE UINTEGER indir,@missione2 : stampa() : PRINT AT 5,3; PAPER naz; "\{i7}\{b1} 2 " : k = 7

  IF miss(15,3) = 3 THEN POKE UINTEGER indir,@missione3 : stampa() : PRINT AT 7,3; PAPER naz; "\{i7}\{b1} 3 " : k = 9

  PRINT AT k,7; "MISSIONS MENU"; AT k,3; PAPER naz; sce0$

attesa13:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 51 THEN GOTO attesa13

  IF q = 48 THEN bip(): GOTO missioni

  x = VAL INKEY$

  ' Corregge la pressione accidentale dei tasti 2 e/o 3 se non ci sono missioni programmate con quei numeri d'ordine

  IF miss(15,x) > 0 THEN
    GOTO mis
  ELSE
    GOTO attesa13
  END IF

mis:

  bip()

  riepmis()

  stampaeff()

  premitasto()

  GOTO vedimiss

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

main:

  bip()

  ' Vengono salvate solo le variabili modificate dal programma.

  x = 1
  DO
    POKE @memo + 10 + x, stru(1,x)
    POKE @memo + 19 + x, stru(2,x)
    POKE @memo + 28 + x, stru(3,x)
    x = x + 1
  LOOP UNTIL x = 10

  x = 1
  DO
    POKE @memo + 230 + x, qt(x)
    x = x + 1
  LOOP UNTIL x = 20

  x = 1
  DO
    POKE @memo + 330 + x, miss(1,x)
    POKE @memo + 333 + x, miss(2,x)
    POKE @memo + 336 + x, miss(3,x)
    POKE @memo + 339 + x, miss(4,x)
    POKE @memo + 342 + x, miss(5,x)
    POKE @memo + 345 + x, miss(6,x)
    POKE @memo + 348 + x, miss(7,x)
    POKE @memo + 351 + x, miss(8,x)
    POKE @memo + 354 + x, miss(9,x)
    POKE @memo + 357 + x, miss(10,x)
    POKE @memo + 360 + x, miss(11,x)
    POKE @memo + 363 + x, miss(12,x)
    POKE @memo + 366 + x, miss(13,x)
    POKE @memo + 369 + x, miss(14,x)
    POKE @memo + 372 + x, miss(15,x)
    POKE @memo + 375 + x, miss(16,x)
    POKE @memo + 378 + x, effmis(x)
    POKE @memo + 381 + x, totalmis(x)
    x = x + 1
  LOOP UNTIL x = 4

  x = 1
  DO
    POKE @memo + 384 + x, mpr(x)
    x = x + 1
  LOOP UNTIL x = 17

  x = 1
  DO
    POKE @memo + 400 + x, pm(x)
    x = x + 1
  LOOP UNTIL x = 7

  POKE UINTEGER @memo + 408, somma
  POKE @memo + 415, pen
 
  x = 1
  DO
    POKE @memo + 415 + x, CODE pilost$(x)
    x = x + 1
  LOOP UNTIL x = 11

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------

  ' Ritorna a "_main.bas"

  POKE @segue, 1

  END

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Mostra il messaggio "premi un tasto" e mette il gioco in pausa finché non si preme un tasto

SUB premitasto()

  FLASH 0: PRINT AT 22,8; "\{p3}\{i7}\{b1} PRESS ANY KEY ": INK 0: PAUSE 0
  bip()

END SUB

  ' Stampa l'avviso "struttura necessaria"

SUB nostru()

  CLS
  POKE UINTEGER indir,@strunec
  stampa()
  premitasto()

END SUB

  ' Stampa una lista di numeri per le opzioni.
  ' Parametri: lin,col = coordinate iniziali; pun = numero di punti

SUB lista(lin AS UBYTE, col AS UBYTE, pun AS UBYTE)

  n = 1
  DO
    PRINT at lin,col; PAPER naz; INK 7; BRIGHT 1; " ";n;" "
	lin = lin + 2
	n = n + 1
  LOOP UNTIL n > pun

  PRINT AT lin+1,col+4; "BACK"; AT lin+1,col; PAPER naz; "\{i7}\{b1} 0 "

END SUB

  ' Pulisce le righe da 2 a 21

SUB pulisci()
  
  n = 2
  DO
    PRINT AT n,0; rigav$
	n = n + 1
  LOOP UNTIL n = 22

END SUB

  ' Inserisce un valore numerico. Il valore è conservato in i

SUB inp()

   v$=""
   cancerig()
   PRINT AT 21,2; "CHOICE: "; "\{f1} "; "\{f0}  "

10 PAUSE 0
   
   IF CODE INKEY$ = 13 THEN GOTO 20
   IF CODE INKEY$ = 12 AND LEN v$ > 0 THEN v$ = v$(TO LEN (v$)-1) :	 GOTO 15
   IF CODE INKEY$ < 48 OR CODE INKEY$ > 57 THEN GOTO 10
   IF LEN v$ < 2 THEN v$ = v$+INKEY$
   
15 PRINT AT 21,10; v$; "\{f1} "; "\{f0} "
   GOTO 10

20 IF v$ = "" THEN GOTO 10

   cancerig()
   i = VAL(v$) 

END SUB

  ' Cancella le ultime tre righe dello schermo

SUB cancerig()

  n = 21
  DO
    PRINT AT n,0; rigav$
    n = n + 1
 LOOP UNTIL n = 24

END SUB

  ' Stampa l'elenco dei piloti

SUB elenpilo()

  CLS
  
  k = 2
  n = 1

  DO 
    IF pilost$(n) = "N" OR pilost$(n) = "X" THEN GOTO nessuno
    PRINT AT k,1; n; "."; pilo$(n); AT k,15; abi(1,n); AT k,18; abi(2,n); AT k,21; abi(3,n); AT k,24; abi(4,n); AT k,27; abi(5,n); AT k,30; pilost$(n)
    k = k + 1
nessuno:
    n = n + 1
  LOOP UNTIL n = 11

  ' Se k rimane invariato non ci sono piloti

  IF k = 2 THEN
    CLS
    POKE UINTEGER indir,@noncisono
    stampa()
    PRINT AT 11,16; FLASH 1; plt$
    premitasto()
    GOTO esci2
  END IF

  PRINT INK naz; AT 0,15;"BP EV DO AP EN ST"

esci2:

END SUB

  ' Stampa l'intestazione della pianificazione missioni

SUB intemis()

 pulisci()

 PRINT INK naz; AT 3,17;"QNT"; AT 3,21; "MAS"; AT 3,25; "EFF"

END SUB

  ' Rivedi tutti i dati della missione.
  ' x è il numero identificativo della missione e va specificato prima di richiamare il sottoprogramma

SUB riepmis()
  
  CLS

  ' k indica la riga dove stampare

  k = 7  

  IF miss(2,x) = 1 THEN v$ = "EARTH ORBIT"
  IF miss(2,x) = 2 THEN v$ = "LUNAR ORBIT"
  IF miss(2,x) = 3 THEN v$ = "MOON LANDING"

  ' Mostra veicolo, destinazione, vettore ed eventuale potenziamento

  POKE UINTEGER indir,@riepil
  stampa()
  w = miss(1,x): PRINT AT 3,10; mate$(w); AT 4,10;v$
  w = miss(4,x): PRINT AT 5,10; mate$(w)
  IF miss(5,x) = 1 THEN
    v$ = "YES"
  ELSE
    v$ = "NO"
  END IF
  PRINT AT 6,10; v$; AT 1,6; PAPER naz; "\{i7}\{b1} MISSION "; x; " SUMMARY "

  ' Modulo lunare sì/no

checklem:

  w = miss(3,x)

  ' Modulo lunare non presente

  IF w = 0 THEN GOTO checkms

  ' Modulo lunare presente

  v$ = mate$(w)
  PRINT AT k,1; "LUNAR MOD.: "; v$
  
  ' Passa alla riga successiva

  k = k + 1

  ' Modulo di servizio sì/no

checkms:

  ' Modulo di servizio non presente

  IF miss(6,x) = 0 AND miss(7,x) = 0 THEN GOTO checkagga
  IF miss(6,x) = 1 THEN v$ = "A"
  IF miss(7,x) = 1 THEN v$ = "B"
  PRINT AT k,1; "SERV.MOD.: "; v$

  ' Passa alla riga successiva

  k = k + 1

  ' Modulo di aggancio sì/no

checkagga:

  ' Modulo aggancio non presente

  IF miss(8,x) = 0 THEN GOTO checktute

  ' Modulo aggancio presente

  PRINT AT k,1; mate$(11)
 
  ' Passa alla riga successiva

  k = k + 1

  ' Tute AEV sì/no

checktute:

  w = miss(9,x)

  ' Tuta AEV non presente

  IF w = 0 THEN GOTO checkequi

  ' Tuta AEV presente

  PRINT AT k,1; mate$(12);" (";w;")"
  
  ' Passa alla riga successiva

  k = k + 1

  ' Lista equipaggio

checkequi:

  ' Se la missione è senza equipaggio va direttamente alla fine
  ' (se il volo è con equipaggio c'è sempre almeno un pilota)

  w = miss(10,x)

  IF w = 0 THEN GOTO fineriep

  ' Avanza di una riga

  k = k + 1

  PRINT AT k,1; "CREW:"

  k = k + 1

  ' Controlla quali sono i piloti e ne stampa il nome

  n = 10
  DO
    w = miss(n,x)
    IF w > 0 THEN PRINT AT k,3; pilo$(w): k = k + 1
    n = n + 1
  LOOP UNTIL n = 14

fineriep:

END SUB

  ' Stampa l'efficienza globale della missione. Specificare x prima di richiamare

SUB stampaeff()

  PRINT AT 18,1; "GLOBAL EFFIC.: ";effmis(x);"%"

  IF z > 0 THEN PRINT AT 19,1; "(PENALTY: -";z;"%)"

END SUB


  ' Azzera i parametri della missione in caso di annullamento o di completamento

SUB azzemis()

  ' Azzera tutti i valori e torna al menù missioni.
  ' i è il numero della missione

  n = 1
  DO
    mpr(n) = 0
	miss(n,i) = 0
    n = n + 1
  LOOP UNTIL n = 17

  somma = 0

END SUB

  ' Stampa l'avviso "Questa missione necessita di:"

SUB necessita()

  POKE UINTEGER indir,@necedi: stampa()

END SUB

  ' Cancella i piloti dalla missione in corso di programmazione

SUB cancepilo()

  n = 10
  DO
    mpr(n) = 0
    n = n + 1
  LOOP UNTIL n = 14

END SUB

  ' Verifica se i piloti hanno le abilità richieste dalla missione

SUB veripilo()

  k = 0

  n = 10

check01:

  ' Prende il numero di riferimento del pilota memorizzato in mpr(n).
  ' Se il pilota è assente (y = 0) il controllo termina
  
  y = mpr(n): IF y = 0 THEN GOTO check02
  
  ' Controlla se l'abilità indicata da x è 0
  
  IF abi(x,y) = 0 THEN k = k + 1
  
  ' Aumenta il contatore per passare al pilota successivo
  
  n = n + 1

  ' Se non abbiamo finito di esaminare tutti i piloti, il ciclo si ripete
  
  IF n < 14 THEN GOTO check01

check02:

END SUB

  ' Stampa l'avviso "selezione non valida" e torna alla scelta dell'equipaggio

SUB noab()

  i = i + 1

  POKE UINTEGER indir,@noabil
  stampa()

  PRINT AT 19,0; rigav$; AT i,1; abl$(x)

END SUB

  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

norampa:
ASM
  DEFB 22, 11, 3
  DEFB 18, 1
  DEFM " NO AVAILABLE LAUNCH PADS "
  DEFB 255
END ASM

massaec:
ASM
  DEFB 22, 10, 5
  DEFM "CHOOSE ANOTHER CARRIER"
  DEFB 22, 8, 8
  DEFB 18, 1
  DEFM " EXCESSIVE MASS "
  DEFB 255
END ASM

chiedides:
ASM
  DEFB 22, 3, 1
  DEFM "1.EARTH ORBIT"
  DEFB 13
  DEFM " 2.LUNAR ORBIT"
  DEFB 13
  DEFM " 3.MOON LANDING"
  DEFB 22, 19, 1
  DEFM "DESTINATION?"
  DEFB 255
END ASM

necedi:
ASM
  DEFB 22, 3, 1
  DEFM "FOR THIS MISSION YOU NEED:"
  DEFB 255
END ASM

nonadatto:
ASM
  DEFB 22, 10, 3
  DEFM "YOU CAN"
  DEFB 195
  DEFM "REACH THE MOON"
  DEFB 22, 11, 7
  DEFM "WITH THIS ROCKET."
  DEFB 255
END ASM

boos:
ASM
  DEFB 22, 10, 2
  DEFM "AN AUXILIARY PART IS NEEDED"
  DEFB 22, 11, 7
  DEFB 204
  DEFM "REACH THE MOON."
  DEFB 255
END ASM

nonnehai:
ASM
  DEFB 22, 13, 6
  DEFM "YOU DO "
  DEFB 195
  DEFM "HAVE ANY."
  DEFB 255
  DEFB 255
END ASM

materialino:
ASM
  DEFB 22, 14, 9
  DEFB 18, 1
  DEFM " PARTS NEEDED "
  DEFB 255
END ASM

noabil:
ASM
  DEFB 22, 13, 6
  DEFB 18, 1
  DEFM " INVALID SELECTION "
  DEFB 18, 0
  DEFB 22, 15, 0
  DEFM "REQUIRED ABILITIES:"
  DEFB 255
END ASM

misspianok:
ASM
  DEFB 22, 11, 8
  DEFM "MISSION PLANNED"
  DEFB 255
END ASM

nomissp:
ASM
  DEFB 22, 11, 5
  DEFB 18, 1
  DEFM " NO PLANNED MISSIONS "
  DEFB 255
END ASM

riepil:
ASM
  DEFB 22, 3, 1
;  DEFM "MISSION   SUMMARY"
;  DEFB 13
;  DEFB 13
  DEFM "S'CRAFT:"
  DEFB 13
  DEFM " DESTIN.:"
  DEFB 13
  DEFM " CARRIER:"
  DEFB 13
  DEFM " BOOSTER:"
  DEFB 255
END ASM

pilono:
ASM
  DEFB 22, 21, 9
  DEFB 18, 1
  DEFM "ONAUT UNAVAILABLE "
  DEFB 255
END ASM

noncisono:
ASM
  DEFB 22, 11, 3
  DEFB 18, 1
  DEFM " THERE ARE NO"
  DEFB 22, 11, 21
  DEFM "ONAUTS "
  DEFB 255
END ASM

strunec:
ASM
  DEFB 22, 11, 7
  DEFB 18, 1
  DEFM " FACILITY NEEDED "
  DEFB 255
END ASM

missione1:
ASM
  DEFB 22, 3, 7
  DEFM "MISSION 1"
  DEFB 255
END ASM

missione2:
ASM
  DEFB 22, 5, 7
  DEFM "MISSION 2"
  DEFB 255
END ASM

missione3:
ASM
  DEFB 22, 7, 7
  DEFM "MISSION 3"
  DEFB 255
END ASM