;----------------------------------------------------------------
; AD LUNAM PLUS
; LM per caricamento senza header in modalità USR 0
; (C) 2020 Alessandro Grussu
;
; Tutti i blocchi da caricare nei vari banchi cominciano a 49152.
; Il riferimento del banco corrisponde a:
;
; 16 + n
;
; dove n = numero del banco.
;
; Il banco 0 (memoria di lavoro) va caricato per ultimo.
;----------------------------------------------------------------

  ; -----------------
  ; VERSIONE ITALIANA
  ; -----------------

; Equivalenze lunghezza blocchi
; -----------------------------
  LSCREEN  EQU 3156
  BANCO_1  EQU 13767
  BANCO_3  EQU 15930
  BANCO_4  EQU 15123
  BANCO_6  EQU 14824
  BANCO_7  EQU 6398
  RESOURCE EQU 14218
  GESTIONE EQU 39005

  ORG 48500

  DI                 ; inizializza USR 0
  LD HL,(23613)
  INC HL
  LD (HL),019
  DEC HL
  LD (HL),003
  DEC HL
  LD (HL),027
  DEC HL
  LD (HL),118
  DEC HL
  LD (HL),000
  DEC HL
  LD (HL),081
  LD SP, HL
  LD BC,32765
  LD A,016           ; 16 = USR 0; 48 = modalità 48K
  OUT (C), A
  RES 4, (IY+001)
  EI

  XOR A              ; (64 per BRIGHT 1)
  LD   (23624),A     ; le ultime due righe hanno INK e PAPER 0
  CALL 3503          ; CLS
 
  LD IX,49152
  LD DE,LSCREEN      ; lunghezza della schermata di caricamento compressa
  CALL CARICA

  CALL 49152         ; decomprime la schermata di caricamento

; BANCO 1
  
  LD A,017           ; indirizza il banco 1

  LD BC,32765
  OUT (C),A
  
  LD IX,49152
  LD DE,BANCO_1      ; lunghezza del blocco primo livello
  
  CALL CARICA

; BANCO 3

  LD A,019           ; indirizza il banco 3

  LD BC,32765
  OUT (C),A
  
  LD IX,49152
  LD DE,BANCO_3
  
  CALL CARICA

; BANCO 4

  LD A,020           ; indirizza il banco 4

  LD BC,32765
  OUT (C),A
  
  LD IX,49152
  LD DE,BANCO_4
  
  CALL CARICA

; BANCO 6

  LD A,022           ; indirizza il banco 6

  LD BC,32765
  OUT (C),A
  
  LD IX,49152
  LD DE,BANCO_6
  
  CALL CARICA

;  BANCO 7

  LD A,023           ; indirizza il banco 7

  LD BC,32765
  OUT (C),A
  
  LD IX,49152
  LD DE,BANCO_7
  
  CALL CARICA

; Caricamento del programma principale

; BANCO 0 

  LD A,016           ; attiva il banco 0
  LD BC,32765
  OUT (C),A

  LD IX,25044        ; origine
  LD DE,RESOURCE     ; lunghezza del blocco
 
  CALL CARICA

  JP GESTIONE
  
CARICA:

  LD A,255 
  SCF      
  CALL 1366
  RET
  
