  ; Schema dei blocchi programma
  ; ----------------------------
  ; Banco 1:
  ; MAIN
  ; ----------------------------
  ; Banco 3:
  ; RICERCA
  ; CONTMIS
  ; ----------------------------
  ; Banco 4:
  ; MISSIONI
  ; FINETURNO
  ; ----------------------------
  ; Banco 6:
  ; STRUTTURE
  ; VITTORIA
  ; ----------------------------
  ; Banco 7:
  ; INIT
  ; ----------------------------

  ; Le lunghezze IND... ecc. si riferiscono alla versione localizzata.

  ; -----------------
  ; VERSIONE ITALIANA
  ; -----------------

  INDCONT EQU 49152+4695    ; indirizzo blocco CONTMIS compresso
  INDFINT EQU 49152+7449    ; indirizzo blocco FINETURNO compresso
  INDVITT EQU 49152+4636    ; indirizzo blocco VITTORIA compresso
  SEGUE   EQU 25043         ; byte di collegamento tra i blocchi
  DISSO   EQU 25812         ; dissolvenza sinistra-destra
  START   EQU 39265         ; indirizzo di partenza dei blocchi di programma

   ORG 25044

   BUFFER EQU 25042

  ; Set di caratteri personalizzato

  INCBIN "adfont.bin"

  ; Dissolvenza sinistra-destra
    
   ADDR EQU $         ; 25812
  
   LD IX,ADDR+134
   XOR A
   LD (IX+000),A
   CALL ADDR+26
   LD A,(IX+000)
   CP 037
   JP Z,ADDR+165
   HALT
   INC A
   LD (IX+000),A
   JR ADDR+8
   LD A,(IX+000)
   LD (IX+001),A
   LD B,004           ; velocità
   PUSH BC
   CALL ADDR+49
   LD A,(IX+001)
   DEC A
   LD (IX+001),A
   POP BC
   DJNZ ADDR+34
   RET
   LD A,(IX+001)
   OR A
   RET M
   CP 032
   RET NC
   LD A,B
   CP 001
   JR Z,ADDR+102
   LD C,A
   LD B,000
   LD HL,ADDR+157
   ADD HL,BC
   LD A,(HL)
   LD (ADDR+88),A
   LD A,(IX+001)
   LD L,A
   LD H,064
   LD B,192
   LD A,R
   AND 031
   LD D,A
   LD A,(DE)
   LD C,170
   OR C
   LD C,A
   LD A,(HL)
   AND C
   LD (HL),A
   INC H
   INC DE
   CALL ADDR+120
   DJNZ ADDR+86
   RET
   LD A,(IX+001)
   LD L,A
   LD H,088
   LD B,024
   LD DE,00032
   LD C,63            ; codice attributi di ricopertura dello schermo (orig. 0)
   LD (HL),C
   ADD HL,DE
   DJNZ ADDR+115
   RET
   LD A,H
   AND 007
   RET NZ
   LD A,L
   ADD A,032
   LD L,A
   RET C
   LD A,H
   SUB 008
   LD H,A
   RET
   DEC H
   LD E,000
   NOP
   NOP
   NOP
   LD HL,22528
   PUSH HL
   POP DE
   INC E
   LD BC,00767
   LD (HL),A
   LDIR
   HALT
   HALT
   HALT
   HALT
   HALT
   RET
   LD D,L
   XOR D
   LD DE,34881
   LD B,H
   LD (00033),HL
   LD B,B
   PUSH HL
   POP DE
   INC E
   LD BC,06143
   LD (HL),L
   LDIR
   RET

  ; ORG 25990

; -----------------------------------------------------------------------------
; "Agile" integrated RCS+ZX7 decoder by Einar Saukas (150 bytes)
; -----------------------------------------------------------------------------
; Parameters:
;   HL: source address (compressed data)
;   DE: destination address (decompressing)
; -----------------------------------------------------------------------------

dzx7:
        ld      a, $80
copy_byte_loop_rcs:
        ex      af, af'
        call    copy_byte               ; copy literal byte
main_loop_rcs:
        ex      af, af'
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        jr      nc, copy_byte_loop_rcs  ; next bit indicates either literal or sequence
        jr      length_size_start

copy_byte_loop:
        ldi                             ; copy literal byte
main_loop:
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        jr      nc, copy_byte_loop      ; next bit indicates either literal or sequence

length_size_start:
; determine number of bits used for length (Elias gamma coding)
        push    de
        ld      bc, 1
        ld      d, b
length_size_loop:
        inc     d
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        jr      nc, length_size_loop
        jp      length_value_start

; determine length
length_value_loop:
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        rl      c
        rl      b
        jr      c, exit                 ; check end marker
length_value_start:
        dec     d
        jr      nz, length_value_loop
        inc     bc                      ; adjust length

; determine offset
        ld      e, (hl)                 ; load offset flag (1 bit) + offset value (7 bits)
        inc     hl
        defb    $cb, $33                ; opcode for undocumented instruction "SLL E" aka "SLS E"
        jr      nc, offset_end          ; if offset flag is set, load 4 extra bits
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        rl      d                       ; insert first bit into D
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        rl      d                       ; insert second bit into D
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        rl      d                       ; insert third bit into D
        add     a, a                    ; check next bit
        call    z, load_bits            ; no more bits left?
        ccf
        jr      c, offset_end
        inc     d                       ; equivalent to adding 128 to DE
offset_end:
        rr      e                       ; insert inverted fourth bit into E

; copy previous sequence
        ex      (sp), hl                ; store source, restore destination
        push    hl                      ; store destination
        sbc     hl, de                  ; HL = destination - offset - 1
        pop     de                      ; DE = destination
        ex      af, af'
        ld      a, h                    ; A = 010RRccc
        cp      $58
        jr      c, copy_bytes
        ldir
        pop     hl                      ; restore source address (compressed data)
        ex      af, af'
        jp      main_loop

copy_bytes:
        push    hl
        ex      de, hl
        call    convert
        ex      de, hl
        call    copy_byte
        pop     hl
        inc     hl
        jp      pe, copy_bytes
        pop     hl                      ; restore source address (compressed data)
        jr      main_loop_rcs

load_bits:
        ld      a, (hl)                 ; load another group of 8 bits
        inc     hl
        rla
        ret

copy_byte:
        push    de
        call    convert
        ldi
exit:
        pop     de
        inc     de
        ret

; Convert an RCS address 010RRccc ccrrrppp to screen address 010RRppp rrrccccc
; (Note: replace both EX AF,AF' with PUSH AF/POP AF if you want to preserve AF')
convert:
        ld      a, d                    ; A = 010RRccc
        cp      $58
        ret     nc
        xor     e
        and     $f8
        xor     e                       ; A = 010RRppp
        push    af
        xor     d
        xor     e                       ; A = ccrrrccc
        rlca
        rlca                            ; A = rrrccccc
        pop     de                      ; D = 010RRppp
        ld      e, a                    ; E = rrrccccc
        ret

; -----------------------------------------------------------------------------

  ; ORG 26140                            ; Lunghezza in byte

  INCBIN "R-ZX7.bin"                     ; 7893

  ; ORG 34033

  INCBIN "cm_lancio-ZX7.bin"             ; 1819

  ; ORG 35852

  INCBIN "scrivania-ZX7.bin"             ; 698

  ; ORG 36550

  INCBIN "animfont.bin"                  ; 520

  ; ORG 37070

  ; Suono "bip"

  LD D,120
  LD E,98
  LD B,28
GIRO1:  PUSH BC
  LD A,(23624)
  SRL A
  SRL A
  SRL A
  SET 4,A
  OUT (254),A
  LD B,D
GIRO2:  NOP
  NOP
  NOP
  DJNZ GIRO2
  RES 4,A
  OUT (254),A
  LD B,E
GIRO3: NOP
  NOP
  NOP
  DJNZ GIRO3
  NOP
  NOP
  NOP
  NOP
  POP BC
  DJNZ GIRO1
  RET

  ; ORG 37114

INNINAZ:

  LD HL,INNI
  LD DE,62400
  CALL dzx7
  CALL 62400
  RET

INNI:  INCBIN "Inni-ZX7.bin"  ; da eseguire a 62400

  ; ORG 39005

  ; --------------------------------------------------
  ; ---------- INIZIO PROGRAMMA DI GESTIONE ----------
  ; --------------------------------------------------

INIZIO:

  LD A,7
  CALL 8859          ; BORDER 7

;  CALL DISSO

  ; --------------------------------------
  ; ---------- CICLO PRINCIPALE ----------
  ; --------------------------------------

CICLO:

  CALL DISSO

  ; Controlla il valore di SEGUE

  LD A,(SEGUE)

  CP 8
  JR Z, INIT         ; mostra punteggio - vittoria

  CP 9
  JR Z, INIT         ; mostra punteggio - sconfitta
  
  CP 1
  JR Z, MAIN

  CP 2
  JR Z, RICERCA

  CP 3
  JR Z, MISSIONI

  CP 4
  JR Z, STRUTTURE

  CP 5
  JR Z, CONTMIS

  CP 6
  JR Z, FINETURNO

  CP 7
  JR Z, VITTORIA

  ; se SEGUE è zero (subito dopo il caricamento) o di qualsiasi altro valore va direttamente a INIT

INIT:

  LD A,23            ; seleziona il banco 7
  CALL PRELOAD

  LD HL,49152

  JR AVVIO           ; fa partire il blocco di inizializzazione

MAIN:

  LD A,17            ; seleziona il banco 1
  CALL PRELOAD

  LD HL,49152
  JR AVVIO

RICERCA:

  LD A,19            ; seleziona il banco 3
  CALL PRELOAD

  LD HL,49152
  JR AVVIO

MISSIONI:

  LD A,20            ; seleziona il banco 4
  CALL PRELOAD

  LD HL,49152
  JR AVVIO

STRUTTURE:

  LD A,22            ; seleziona il banco 6
  CALL PRELOAD

  LD HL,49152
  JR AVVIO

CONTMIS:

  LD A,19            ; seleziona il banco 3
  CALL PRELOAD

  LD HL,INDCONT
  JR AVVIO

FINETURNO:

  LD A,20            ; seleziona il banco 4
  CALL PRELOAD
  LD HL,INDFINT
  JR AVVIO

VITTORIA:

  LD A,22            ; seleziona il banco 6
  CALL PRELOAD
  LD HL,INDVITT

AVVIO:

  LD DE,START
  CALL dzx7          ; decomprime il blocco
  
  CALL START         ; avvia il blocco

  JP CICLO

  ; ----------------------------------------------
  ; ---------- ROUTINE DI COPIA (USR 0) ----------
  ; ----------------------------------------------

PRELOAD:             ; imposta il banco da cui copiare i dati nel banco 0
  
  LD (COPIA+2),A
  LD (COPIA+38),A
  LD (COPIA+74),A

  ; COPIA copia i dati dai banchi 1/3/4/6/7 al banco 0 usando il banco 5 (memoria video) come buffer.
  ; PRELOAD imposta i byte agli indirizzi COPIA+2, COPIA+38 e COPIA+74 per cambiare banco.
  ; Il banco si cambia aggiungendo 16 al numero del banco stesso, es. per il banco 1: 17 (1 + 16).
  
COPIA:

  DI

  LD A,0             ; attiva il banco impostato da PRELOAD
  LD BC,32765
  OUT (C),A
  LD HL,49152        ; inizio dati da copiare
  LD DE,16384        ; destinazione
  LD BC,6144         ; prima porzione da copiare
  LDIR               ; copia

  LD A,016           ; attiva il banco 0
  LD BC,32765
  OUT (C),A
  LD HL,16384        ; copia i primi 6144 byte
  LD DE,49152        ; dal banco 5 al banco 0
  LD BC,6144
  LDIR

  LD A,0             ; torna al banco impostato da PRELOAD
  LD BC,32765
  OUT (C),A
  LD HL,55296        ; punta alla seconda porzione di dati
  LD DE,16384        ; e la copia nel banco 5
  LD BC,6144
  LDIR

  LD A,016           ; attiva il banco 0
  LD BC,32765
  OUT (C),A
  LD HL,16384        ; copia la seconda porzione
  LD DE,55296        ; nel banco 0
  LD BC,6144
  LDIR

  LD A,0             ; torna al banco impostato da PRELOAD
  LD BC,32765
  OUT (C),A
  LD HL,61440        ; punta alla terza porzione di dati
  LD DE,16384        ; e la copia nel banco 5
  LD BC,4096
  LDIR

  LD A,016           ; attiva il banco 0
  LD BC,32765
  OUT (C),A
  LD HL,16384        ; copia la terza porzione nel banco 0
  LD DE,61440        ; completando così il trasferimento
  LD BC,4096         ; dei 16384 byte contenuti nel banco impostato da PRELOAD
  LDIR

  EI
  RET

	; A questo punto i 16384 byte di dati sono copiati nel banco 0 all'indirizzo 49152.
	; Se sono compressi, 49152 è quindi l'indirizzo di partenza da dove cominciare il
	; processo di decompressione.

  ; ORG 39588
